import "package:meta/meta.dart";
import "package:poker/poker.dart";

/**
 *
 */
@immutable
class Matchup {
  Matchup._({
    required this.communityCards,
    required this.playerCardPairs,
    required this.playerMadeHands,
  });

  factory Matchup.showdown({
    required CardSet communityCards,
    required List<CardSet> playerCardPairs,
  }) {
    final List<MadeHand> playerMadeHands = [];

    for (final playerCardPair in playerCardPairs) {
      final madeHand = MadeHand.best(playerCardPair.union(communityCards));

      playerMadeHands.add(madeHand);
    }

    return Matchup._(
      communityCards: communityCards,
      playerCardPairs: playerCardPairs,
      playerMadeHands: playerMadeHands,
    );
  }

  final CardSet communityCards;

  final List<CardSet> playerCardPairs;

  final List<MadeHand> playerMadeHands;
}
