import "package:poker/poker.dart";
import "package:test/test.dart";

void main() {
  group("HandRange.fromString()", () {
    test(
        "HandRange.fromString(\"AQs-ATsAKo-AJo44+\") returns HandRange<AQs-ATsAKo-AJo44+>",
        () {
      final handRange = HandRange.fromString("AQs-ATsAKo-AJo44+");

      print(handRange);

      expect(
        handRange,
        containsAll({
          CardPair(
            Card(rank: Rank.ace, suit: Suit.spade),
            Card(rank: Rank.queen, suit: Suit.spade),
          ),
          CardPair(
            Card(rank: Rank.ace, suit: Suit.heart),
            Card(rank: Rank.queen, suit: Suit.heart),
          ),
          CardPair(
            Card(rank: Rank.ace, suit: Suit.diamond),
            Card(rank: Rank.queen, suit: Suit.diamond),
          ),
          CardPair(
            Card(rank: Rank.ace, suit: Suit.club),
            Card(rank: Rank.queen, suit: Suit.club),
          ),
        }),
      );
    });
  });
}
